(*************************************************************************
*                                                                        *
*    procedure  AITKEN  from unit  NUMERIK                               *
*                                                                        *
**************************************************************************
    *                                                                    *
    *  J. Desteffani IA85                     16.12.1986 - 03.02.1987    *
    *                                                                    *
    *  p u r p o s e :                                                   *
    *    Interpolation nach Aitken - Neville                             *
    *    (siehe Numerik - 7.1.4)                                         *
    *                                                                    *
    *  e n t r i e s :                                                   *
    *    PROCEDURE do_aitken;                                            *
    *                                                                    *
    **********************************************************************)

PROCEDURE do_aitken;

   VAR
      go_on        :boolean;
      i, j         :integer;
      ns           :real;
      x, p         :T_Vektor;

BEGIN
   go_on:= true;
   ns:= N_real_Ask (20);
   Message_real_1:= ns;
   N_Message (52);
   i:= 1;
   REPEAT
      IF N_Ask (35) THEN BEGIN
         x[i]:= input_real;
         IF (i > 1) and (x[i] <= x[i-1]) THEN BEGIN
            N_Error (71);
         END
         ELSE BEGIN
            p[i]:= N_real_Ask (21);
            writeln;
            Message_real_1:= x[i];
            N_Message (50);
            write (' ');
            Message_real_1:= p[i];
            N_Message (50);
            write ('>');
            FOR j:= i-1 DOWNTO 1 DO BEGIN
               p[j]:=p[j]+(ns-x[j])*(p[j+1]-p[j])/(x[i]-x[j]);
               Message_real_1:= p[j];
               N_Message (50);
               write (' ');
            END;
            i:= i+1;
         END;
      END
      ELSE BEGIN
         go_on:= false;
      END;
   UNTIL (not go_on) or (i > max_Ind);
END;
